const { conversation,Media } = require('@assistant/conversation');
const functions = require('firebase-functions');

const app = conversation({debug: true});


const {MediaObject} = require('actions-on-google');

var https = require('https');
var token = "";

function acapela_cloud_login() {
    
  return new Promise(((resolve, reject) => {
      
    var options = {
        host: 'www.acapela-cloud.com',
        port: 443,
        path: '/api/login/',
        method: 'POST',
        headers: {
            'Content-Type': 'application/json'
        }  
     };
     
    var postData = JSON.stringify({
        'email' : '',
        'password' : '',
    }); 
    
    const request =  https.request(options, (response) => {
        
        let returnData = '';
        console.log('statusCode:', response.statusCode);
        console.log('headers:', response.headers);
        
        response.on('data', (d) => {
            returnData += d;
        });
        
        response.on('end', () => {
            resolve(JSON.parse(returnData));
        });
        
        response.on('error', (error) => {
            reject(error);
         });
 
    });
   
    
    request.write(postData);
    request.end();

    
  }));
}

function acapela_cloud_request(token,voice,text) {
    
    // Build TTS command request 
    var output="stream";
    var type="mp3";  
    var bitrate="48";
    var samplerate="22050";
    var url = 'https://www.acapela-cloud.com/api/command/' + "?voice=" + voice + "&text=" + encodeURIComponent(text) + "&output=" + output + "&type=" + type + "&samplerate=" +  samplerate + "&bitrate=" +  bitrate + "&token=" + token;
    
    return url;

}

app.handle('speak', conv => {
  
  
    return acapela_cloud_login()
    .then( function( response ){
      token = response.token;
      // Build TTS command
      var url = acapela_cloud_request(token,"Sharon22k_HQ","Hello I'm using Acapela Cloud to talk with you on Google Assistant.");
 
      
  		conv.add(new Media({
      mediaObjects: [
        {
          name: 'Media name',
          description: 'Media description',
          url: url
        }
      ],
      mediaType: 'AUDIO'
    }));
     
    
      
   	return Promise.resolve();
    })
    .catch( function( err ){
    	conv.add("Uh oh, something happened. " + err);
    	return Promise.resolve();  
    });

  
});


// Media Status
app.handle('media_status', (conv) => {
  const mediaStatus = conv.intent.params.MEDIA_STATUS.resolved;
  switch(mediaStatus) {
    case 'FINISHED':
      conv.add('Media has finished playing.');
      break;
    case 'FAILED':
      conv.add('Media has failed.');
      break;
    case 'PAUSED':
      conv.add(new Media({
        mediaType: 'MEDIA_STATUS_ACK'
      }));
      break;
    case 'STOPPED':
      conv.add(new Media({
        mediaType: 'MEDIA_STATUS_ACK'
      }));
      break;
    default:
      conv.add('Unknown media status received.');
  }
});


exports.ActionsOnGoogleFulfillment = functions.https.onRequest(app);